# """This package provides a complete workflow to users how want to proced to NIRS analysis without particular knowledge.

# This is a webapp with Streamlit.
# GUI shows whatever is needed for Samples Selection based on NIRS spectra and then, to compute a model to predict
#     chemical values on your samples.

# Examples:
#     streamlit run ./app.py
# """
# ##

import streamlit as st
from pathlib import Path

css_file = Path("style/style_model.css")
pages_folder = Path("pages/")
image_path = Path('./images/img-sky.jpg')

import os
import sys
from shutil import rmtree
from pandas import DataFrame, concat
from PIL import Image
import plotly.express as px
from tempfile import NamedTemporaryFile
import numpy as np
from datetime import datetime
import json
from shutil import rmtree, move, make_archive

from utils.data_parsing import JcampParser, CsvParser
from style.layout import  UiComponents
from utils.data_handling import *
from utils.data_parsing import *
from utils.hash import *
from utils.visualize import *
from utils.miscellaneous import ObjectHash
from utils.samsel import RDM, KS
from report import report