## Data loading, handling, and preprocessing
import os
import sys

import glob
from pathlib import Path

import re
import csv
import numpy as np
from pandas import DataFrame, read_csv, concat, Series, json_normalize

from datetime import datetime
from shutil import rmtree, move, make_archive
from hashlib import md5



from typing import Optional, List
import scipy as sc

### Exploratory data analysis-Dimensionality reduction
from pandas.api.types import is_float_dtype

## Images and plots
from PIL import Image
import plotly.express as px
import plotly.graph_objects as go
import plotly.io as pio
import matplotlib.pyplot as plt
from matplotlib import colors
from matplotlib.colors import Normalize
import seaborn as sns

## Web app construction
import streamlit as st
from st_pages import Page, Section, show_pages, add_page_title, hide_pages
from tempfile import NamedTemporaryFile, TemporaryDirectory
# help on streamlit input https://docs.streamlit.io/library/api-reference/widgets

#Library for connecting to SQL DB
import pyodbc

#Library for reading the config file, which is in JSON
import json

# save models
from joblib import dump, load, hash

st.set_option('deprecation.showPyplotGlobalUse', False)



#########################
css_file = Path("style/")
pages_folder = Path("pages/")
